//
//  FUManager.m
//  flutter_nimsdk
//
//  Created by HyBoard on 2019/11/11.
//

#import "FUManager.h"
#import "authpack.h"
#import <sys/utsname.h>
#import <CoreMotion/CoreMotion.h>


@interface FUManager ()
{
    int items[FUNamaHandleTotal];
    int frameID;
    /* 捏脸头道具加载慢，编辑内销毁保存句柄不销毁*/
    int avtarStrongHandle;
    
    dispatch_queue_t makeupQueue;
    
    dispatch_queue_t asyncLoadQueue;
}

@property (nonatomic, strong) CMMotionManager *motionManager;
@property (nonatomic) int deviceOrientation;
/* 重力感应道具 */
@property (nonatomic,assign) BOOL isMotionItem;
/* 当前加载的道具资源 */
@property (nonatomic,copy) NSString *currentBoudleName;
/* 需提示item */
@property (nonatomic, strong) NSDictionary *hintDic;
/* 带屏幕方向的道具 */
@property (nonatomic, strong)NSArray *deviceOrientationItems;
@end

static FUManager *shareManager = NULL;

@implementation FUManager

+ (FUManager *)shareManager
{
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        shareManager = [[FUManager alloc] init];
    });
    
    return shareManager;
}


- (void)loadItems
{
//    /**加载普通道具*/
//    [self loadItem:self.selectedItem completion:nil];
//
//    /**加载美颜道具*/
//    [self loadFilter];
}

/**
 加载普通道具
 - 先创建再释放可以有效缓解切换道具卡顿问题
 */
- (void)loadItem:(NSString *)itemName completion:(void (^)(BOOL finished))completion{
    dispatch_async(asyncLoadQueue, ^{
        self.selectedItem = itemName ;
        
        int destoryItem = self->items[FUNamaHandleTypeItem];
        
        if (itemName != nil && ![itemName isEqual: @"noitem"]) {
            /**先创建道具句柄*/
            NSString *path = [[NSBundle mainBundle] pathForResource:[itemName stringByAppendingString:@".bundle"] ofType:nil];

//            int itemHandle = [FURenderer itemWithContentsOfFile:path];
//
//            // 人像驱动 设置 3DFlipH
//            BOOL isPortraitDrive = [itemName hasPrefix:@"picasso_e"];
//            BOOL isAnimoji = [itemName hasSuffix:@"_Animoji"];
//
//            if (isPortraitDrive || isAnimoji) {
//                [FURenderer itemSetParam:itemHandle withName:@"{\"thing\":\"<global>\",\"param\":\"follow\"}" value:@(1)];
//                [FURenderer itemSetParam:itemHandle withName:@"is3DFlipH" value:@(1)];
//                [FURenderer itemSetParam:itemHandle withName:@"isFlipExpr" value:@(1)];
//                [FURenderer itemSetParam:itemHandle withName:@"isFlipTrack" value:@(1)];
//                [FURenderer itemSetParam:itemHandle withName:@"isFlipLight" value:@(1)];
//            }

//            if ([itemName isEqualToString:@"luhantongkuan_ztt_fu"]) {
//                [FURenderer itemSetParam:itemHandle withName:@"flip_action" value:@(1)];
//            }
//
//            if ([self.deviceOrientationItems containsObject:itemName]) {//带重力感应道具
//                [FURenderer itemSetParam:itemHandle withName:@"rotMode" value:@(self.deviceOrientation)];
//                self.isMotionItem = YES;
//            }else{
//                self.isMotionItem = NO;
//            }
//
//            if ([itemName isEqualToString:@"fu_lm_koreaheart"]) {//比心道具手动调整下
//                [FURenderer itemSetParam:itemHandle withName:@"handOffY" value:@(-100)];
//            }
//            /**将刚刚创建的句柄存放在items[FUNamaHandleTypeItem]中*/
//            self->items[FUNamaHandleTypeItem] = itemHandle;
//            if(completion){
//                completion(YES);
//            }
        }
//        else{
//            if(completion){
//                completion(NO);
//            }
//            /**为避免道具句柄被销毁会后仍被使用导致程序出错，这里需要将存放道具句柄的items[FUNamaHandleTypeItem]设为0*/
//            self->items[FUNamaHandleTypeItem] = 0;
//        }
        NSLog(@"faceunity: load item");
        
//        /**后销毁老道具句柄*/
//        if (destoryItem != 0)
//        {
//            NSLog(@"faceunity: destroy item");
//            [FURenderer destroyItem:destoryItem];
//        }
    });
    
}




@end
